<?php

namespace ClassFile;

use IInterface\Weapon;

class Hero
{
    private $weapon;

    /**
     *
     * 构造方法的参数是一个对象，通过类型约束限制必须为实现Weapon武器接口的对象
     * 在构造方法中，直接将参数传递进来的武器对象赋值到当前对象的属性上
     * 这样,英雄Hero依赖的对象不是在Hero类的内部实例化，而是在外部实例化好，传递到Hero内部的
     *
     * 这就是《依赖注入》，通俗来讲，就是所依赖的对象在外部生成好之后，传递到类内内部的，而不是在
     * 类内部实例化，这种解决依赖的方法就是DI依赖注入
     *
     *
     *
     * Hero constructor.
     *
     * @param Weapon $weapon
     */
    public function __construct(Weapon $weapon)
    {
        $this->weapon = $weapon;
    }
    public function myWeapon()
    {
        echo $this->weapon->attack();
    }
}
